//Normal Map
uniform sampler2D normalmap;

//Viewing und Light Vector
varying vec3 L;
varying vec3 V;

void main (void)
{
   vec3 N;
   vec3 R0;
   

   //normale aus normal map
   N = vec3(texture2D(normalmap, vec2(gl_TexCoord[0])));
   N = (N - 0.5) * 2.0; //in Bereich [-1,1] bringen
   
   //Reflexionsvektoren
   R0 = normalize(-reflect(L,N)); 
   
   
   //Ambient 
   vec4 Iamb = (gl_FrontLightProduct[0].ambient * gl_FrontMaterial.ambient)
				+ (gl_FrontLightProduct[0].ambient * gl_FrontMaterial.ambient);
				
   //Diffuse
   vec4 Idiff = (gl_FrontLightProduct[0].diffuse * gl_FrontMaterial.diffuse * max(dot(N,L), 0.0));

   //Specular
   vec4 Ispec = (gl_FrontLightProduct[0].specular * gl_FrontMaterial.specular 
   				 * pow(max(dot(R0,V),0.0),gl_FrontMaterial.shininess));
               
   
   //endgltige Farbe
   gl_FragColor = gl_FrontLightModelProduct.sceneColor + Iamb + Idiff + Ispec;
   
}