const float pi = 3.1415927;

uniform mat4 light_mvmatrix;

//Viewing und Light Vectors
varying vec3 L;
varying vec3 V;
 
void main(void)
{
   vec3 N;
   vec3 T;
   vec3 B;
   vec3 lightpos;
   vec3 eyepos;
   
   //Texturkoordinaten
   gl_TexCoord[0] = gl_MultiTexCoord0;
   
   //erstelle Tangentenraum	
   vec2 uv = vec2(gl_TexCoord[0]);
   T.x = -2.0*pi*cos(2.0*uv[0]*pi)*sin(uv[1]*pi); /*Ableitungen der parametrischen Kugelbeschreibung nach v*/
   T.y = -2.0*pi*sin(2.0*uv[0]*pi)*sin(uv[1]*pi);
   T.z = 0.0;
   N = normalize(gl_NormalMatrix * gl_Normal);
   T = normalize(gl_NormalMatrix * T);
   B = cross(N, T);
   
   //Lichtposition berechnen und Lichtvektor in Tangentenraum transformieren
   lightpos = vec3(light_mvmatrix*vec4(150.0, 40.0, 150.0,1.0));
   L.x = dot(lightpos, T);
   L.y = dot(lightpos, B);
   L.z = dot(lightpos, N);
   L = normalize(L);
      

   //Viewing Vector in Tangentenraum bringen
   eyepos = vec3(gl_ModelViewMatrix * gl_Vertex);
   V.x = dot(eyepos, T);
   V.y = dot(eyepos, B);
   V.z = dot(eyepos, N);
   V = -normalize(V);
   
   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex; 
}